﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace UT_Cons
{
    class DataReader
    {
        private string _fileName;
        private List<double[]> list = new List<double[]>();

        public DataReader(string fileName)
        {
            _fileName = fileName;
        }

        public bool ReadData(int n)
        {
            if (!File.Exists(_fileName))
            {
                Console.WriteLine("File {0} not found", _fileName);
                return false;
            }
            list.Clear();
            StreamReader file = new StreamReader(_fileName);
            string line;
            while ((line = file.ReadLine()) != null)
            {
                string[] data = line.Split(' ');
                int pos = 0;
                double[] p = new double[n];
                foreach (string s in data)
                {
                    string S = s;
                    if (S.Trim().Length > 1)
                    {
                        double P;
                        Double.TryParse(S, out P);
                        if (pos < n)
                        {
                            p[pos] = P;
                            ++pos;
                        }
                        else
                        {
                            return false;
                        }
                    }                  
                }
                list.Add(p);
            }
            file.Close();
            return true;
        }

        public int GetSize()
        {
            return list.Count;
        }

        public double[] GetColumn(int k)
        {
            double[] data = new double[list.Count];
            int counter = 0;
            foreach (double[] p in list)
            {
                if (p.Length <= k)
                {
                    Console.WriteLine("Data size is wrong");
                    return null;
                }
                data[counter++] = p[k];
            }
            return data;
        }
    }
}
